Subject: bug#60096: 29.0.60; Crash in format_mode_line_unwind_data

From: Eli Zaretskii <[email-masked]>
Date: Sun, 18 Dec 2022 13:40:43 +0200

> Date: Sun, 18 Dec 2022 10:18:18 +0100
> Cc: [email-masked], [email-masked]
> From: martin rudalics <[email-masked]>
> 
>  >> Probably so far we never tried to call 'kill-buffer' from within
>  >> 'set-window-configuration'.  If the only "live" window shows *scratch*,
>  >> *scratch* gets killed and we kill a temporary buffer before we were able
>  >> to recreate *scratch*, window_list will return the empty list.
>  >
>  > Why the empty list?  The buffer gets killed, but windows don't get
>  > killed.  We still have the frame with at least two windows (including
>  > the mini-window).  Right?
> 
> Not if we exclude windows with a nil buffer as suggested above.  The
> delete_all_child_windows call in 'set-window-configuration' sets the
> contents field of every live window on that frame to nil and as long as
> we have not been able to get a live buffer for that window, it will stay
> nil.

Well, you forget *Messages*.  But I get your point.

> That's where all those windows with a nil buffer in your
> investigations come from.  It's simply not safe to deal with windows
> before 'set-window-configuration' has done its work completely.  If we
> think of running Lisp in this time, we have to do it in a completely
> restricted way: Any window, including the selected one, can legitimately
> have a nil buffer then.

With the current code, this is what happens: the window-related
functions called from set-window-configuration either manage to get
along with such windows, or are called via safe_call, which catches
any errors.  And AFAIU the code in set-window-configuration attempts
to make sure that every window we reinstate from the saved
window-configuration will have a valid buffer when we are done looping
over all of the saved windows.